# blow.tcl
#
# fixed a lot of stuff wrong with BLOWCRYPT.V2.4.EGGDROP.TCL-PERPLEX
#
# Commands:
#  msg  !chkey <#channel> <channel_key> - changes channel key (botowners/masters only)
#  msg  !bckeydel - removes user encrypted msg key
#  chan !newkey - creates a random new channel key (botowners/masters only)
#  chan !getkey - msgs the chan key to the user
# 
#  !! BLOWFISH MODULE NEED TO BE LOADED AS ENCRYPTION MODULE !!
#  'checkmodule blowfish' in eggdrop.conf
#
# Diffie-Hellman 1080bit KeyXchange for TCL
# http://fish.sekure.us/DH1080_tcl/linux/DH1080_tcl.so
# http://fish.sekure.us/DH1080_tcl/BSD/DH1080_tcl.so
load DH1080_tcl.so

set enable_newkey 1
set enable_getkey 1

# set to "" for all channels
set getkey_chans "#chan1 #chan2"
set newkey_chans "#chan1 #chan2"

if {$enable_newkey} {
	bind pub n|m !newkey create_newkey
}

if {$enable_getkey} {
	bind pub - !getkey givekey
}

catch {rename putquick putquick2}
catch {rename putserv putserv2}
catch {rename puthelp puthelp2}

proc puthelp {text {option ""}} {
	global blowkey
	if {$option==""} {
		if {![string compare -nocase -length 7 $text "PRIVMSG"] && [info exists blowkey([string tolower [lindex $text 1]])]} {
	  		set pos [string first : $text]
	  		if {$pos==-1} {putlog "BOGOUS MESSAGE";return}
	  		incr pos
			puthelp2 "PRIVMSG [lindex $text 1] :+OK [encrypt $blowkey([string tolower [lindex $text 1]]) [string range $text $pos end]]"
		} else {
			puthelp2 $text
		}
	} else {
	  	if {![string compare -nocase -length 7 $text "PRIVMSG"] && [info exists blowkey([string tolower [lindex $text 1]])]} {
	  		set pos [string first : $text]
	  		if {$pos==-1} {putlog "BOGOUS MESSAGE";return}
	  		incr pos
			puthelp2 "PRIVMSG [lindex $text 1] :+OK [encrypt $blowkey([string tolower [lindex $text 1]]) [string range $text $pos end]]" $option
		} else {
			puthelp2 $text $option
		}
	}
}


proc putserv {text {option ""}} {
	global blowkey
	if {$option==""} {
		if {![string compare -nocase -length 7 $text "PRIVMSG"] && [info exists blowkey([string tolower [lindex $text 1]])]} {
	  		set pos [string first : $text]
	  		if {$pos==-1} {putlog "BOGOUS MESSAGE";return}
	  		incr pos
			putserv2 "PRIVMSG [lindex $text 1] :+OK [encrypt $blowkey([string tolower [lindex $text 1]]) [string range $text $pos end]]"
		} else {
			putserv2 $text
		}
	} else {
	  	if {![string compare -nocase -length 7 $text "PRIVMSG"] && [info exists blowkey([string tolower [lindex $text 1]])]} {
	  		set pos [string first : $text]
	  		if {$pos==-1} {putlog "BOGOUS MESSAGE";return}
	  		incr pos
			putserv2 "PRIVMSG [lindex $text 1] :+OK [encrypt $blowkey([string tolower [lindex $text 1]]) [string range $text $pos end]]" $option
		} else {
			putserv2 $text $option
		}
	}
}


proc putquick {text {option ""}} {
	global blowkey
	if {$option==""} {
		if {![string compare -nocase -length 7 $text "PRIVMSG"] && [info exists blowkey([string tolower [lindex $text 1]])]} {
	  		set pos [string first : $text]
	  		if {$pos==-1} {putlog "BOGOUS MESSAGE";return}
	  		incr pos
			putquick2 "PRIVMSG [lindex $text 1] :+OK [encrypt $blowkey([string tolower [lindex $text 1]]) [string range $text $pos end]]"
		} else {
			putquick2 $text
		}
	} else {
	  	if {![string compare -nocase -length 7 $text "PRIVMSG"] && [info exists blowkey([string tolower [lindex $text 1]])]} {
	  		set pos [string first : $text]
	  		if {$pos==-1} {putlog "BOGOUS MESSAGE";return}
	  		incr pos
			putquick2 "PRIVMSG [lindex $text 1] :+OK [encrypt $blowkey([string tolower [lindex $text 1]]) [string range $text $pos end]]" $option
		} else {
			putquick2 $text $option
		}
	}
}

unbind dcc o|- msg *dcc:msg
bind dcc o|- msg dcc:emsg

proc dcc:emsg {hand idx arg} {
        global botnick
        set who [lindex $arg 0]
        set what [lrange $arg 1 end]
        set tmp ""
        foreach w $what {
                append tmp "$w "
        }
        set what [string trim $tmp " "]
        putquick "PRIVMSG $who :$what"
        putdcc $idx "Msg to $who: $what"
}

unbind dcc o|o say *dcc:say
bind dcc o|o say dcc:esay

proc dcc:esay {hand idx arg} {
        global botnick
        set chan [lindex $arg 0]
        set what [lrange $arg 1 end]      
        set tmp ""
        foreach w $what {
                append tmp "$w "
        }
        set what [string trim $tmp " "]
        if {[validchan $chan]} {   
                if {[botonchan $chan]} {
                        putquick "PRIVMSG $chan :$what"
                        putdcc $idx "Said to $chan: $what"
                } {
                        putdcc $idx "I'm not on $chan"
                }
        } {
                putdcc $idx "I'm not on $chan"
        }
}

proc make_blowkey {templ} {
	set chars "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ-`_/"
#       set chars "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ-`_[]{}\\"
#	set chars "0123456789abcdefghijklmnopqrstuvwxyz-`\\"
#	set chars "abcdefghijklmnopqrstuvwxyz"
	set clen [expr [string length $chars] - 1]
	set key ""
	if {[string is integer $templ]} {
		set templ [string repeat ? $templ]
	}
	for {set i 0} {$i < [string length $templ]} {incr i} {
		set c [string index $templ $i]
		if {$c == "?"} {
			append key [string index $chars [rand $clen]]
		} {
			append key $c
		}
	}
	while {[string index $key 0] == "-" || [string is digit [string index $key 0]]} {
		set key [string replace $key 0 0 [string index $chars [rand $clen]]]
	}
	return $key
}
        
proc create_newkey {nick uhost hand chan arg} {
        global blowkey botnick newkey_chans
        if {(($newkey_chans != "") && ([lsearch -exact $newkey_chans [string tolower $chan]] == -1))} {
                return
        }
        if {[lindex $arg 0] != ""} {
                set ch [string tolower "[lindex $arg 0]"]
        } {
                set ch [string tolower "$chan"] 
        }
	set key [make_blowkey 60]
        if {[onchan "$botnick" "$ch"]} {
    		set blowkey($ch) "$key"
    		save_keys $ch $key
                putserv2 "PRIVMSG $ch :New blowkey created, please update your clients"
        } {
		putserv2 "PRIVMSG $chan :An error occured creating the new blowkey"
	}
}

proc DH1080_KeyXchange { nick } {
        global mypubkey myprivkey
        ## IMPORTANT: the 2 variables should be at least 200 bytes each!
        ## You might run into a crash, if they are too small!
        set myprivkey [string repeat x 300]
        set mypubkey [string repeat x 300]
        DH1080gen "$myprivkey" "$mypubkey"
	putserv "NOTICE $nick :DH1080_INIT $mypubkey"
	return 1
}

proc givekey {nick uhost hand chan arg} {
	global blowkey getkey_chans
        if {(($getkey_chans != "") && ([lsearch -exact $getkey_chans [string tolower $chan]] == -1))} {
                return
        }
        if {[lindex $arg 0] != ""} {
                set ch [string tolower "[lindex $arg 0]"]
        } {
                set ch [string tolower "$chan"]
        }
	set nick [string tolower $nick]
	if {![info exists blowkey($nick)]} {
		DH1080_KeyXchange $nick
		utimer 10 "[list giveit "$nick $ch"]"
		return
	}
	giveit "$nick $ch"
}

proc giveit {param} {
        global blowkey
        set nick [lindex $param 0]
        set ch [lindex $param 1]
        if {[info exists blowkey($nick)]} {
		if {[onchan "$nick" "$ch"]} {
			if {[info exists blowkey($ch)]} {
				putserv "PRIVMSG $nick :The key for $ch is $blowkey($ch)"
			} {
				putserv "PRIVMSG $nick :I don't have a key set for $ch"
			}
		} {
			putserv "PRIVMSG $nick :You aren't in that channel"
		}
	} {
		putserv2 "PRIVMSG $nick :Please keyXchange and retry"
                return 0
	}
	return 1
}

proc encryptedincominghandler {nick host hand chan arg} {
	global blowkey
	if {![info exists blowkey([string tolower $chan])]} {return}
	set tmp [decrypt $blowkey([string tolower $chan]) $arg]
	foreach item [binds pub] {
		if {[lindex $item 2]=="+OK" || [lindex $item 2]=="mcps"} {continue}
		if {[lindex $item 1]!="-|-"} {
			if {![matchattr $hand [lindex $item 1] $chan]} {continue}
		}
		if {[lindex $item 2]==[lindex $tmp 0]} {[lindex $item 4] $nick $host $hand $chan [lrange $tmp 1 end]}
	}
   	foreach item [binds pubm] {
                if {[lindex $item 2]=="+OK" || [lindex $item 2]=="mcps"} {continue}
                if {[lindex $item 1]!="-|-"} {
                        if {![matchattr $hand [lindex $item 1] $chan]} {continue}
                }
                set i [lindex $item 2]
                if {[string match -nocase [lindex $i 0] $chan] && [string match -nocase [lindex $i 1] [lindex $tmp 0]]} {
                        [lindex $item 4] $nick $host $hand $chan [lrange $tmp 0 end]
                }
         }
}

proc encryptedmsgincominghandler {nick host hand arg} {
	global blowkey
	if {![info exists blowkey([string tolower $nick])]} {return}
	set tmp [decrypt $blowkey([string tolower $nick]) $arg]
	foreach item [binds msg] {
		if {[lindex $item 2]=="+OK" || [lindex $item 2]=="mcps"} {continue}
		if {[lindex $item 1]!="-|-"} {
			if {![matchattr $hand [lindex $item 1]]} {continue}
		}
		if {[lindex $item 2]==[lindex $tmp 0]} {[lindex $item 4] $nick $host $hand [lrange $tmp 1 end]}
	 }
        foreach item [binds msgm] {
                if {[lindex $item 2]=="+OK" || [lindex $item 2]=="mcps"} {continue}
                if {[lindex $item 1]!="-|-"} {
                        if {![matchattr $hand [lindex $item 1]]} {continue}
                }
                if {[lindex $item 2]==[lindex $tmp 0]} {[lindex $item 4] $nick $host $hand [lrange $tmp 1 end]}
         }
}

proc bckeydel {nick host hand arg} {
	set nick [string tolower $nick]
	unset ::blowkey($nick)
	puthelp "PRIVMSG $nick :done!"
}

proc keyexinit { nick host handle text dest } {
        global mypubkey myprivkey
	set arg_len [string length $text]
	if { ($arg_len < 192) || ($arg_len > 193) } { return }
	## IMPORTANT: the 2 variables should be at least 200 bytes each!
	## You might run into a crash, if they are too small!
	set myprivkey [string repeat x 300]
	set mypubkey [string repeat x 300]
	DH1080gen "$myprivkey" "$mypubkey"
	putserv "NOTICE $nick :DH1080_FINISH $mypubkey"
	set hispubkey [lindex $text 1]
	DH1080comp "$myprivkey" "$hispubkey"
	set ::blowkey($nick) $hispubkey
	unset hispubkey
}



proc keyexfinish { nick host handle text dest } {
        global mypubkey myprivkey
	set arg_len [string length $text]
	if { ($arg_len < 194) || ($arg_len > 195) } { return }
	set hispubkey [lindex $text 1]
	DH1080comp "$myprivkey" "$hispubkey"
	## $hispubkey now contains the secret key!
	set ::blowkey($nick) $hispubkey
	unset hispubkey
}

proc ch_blowkey {nick host hand args} {
     	global blowkey
    	set args [join $args]
    	set ch [lindex $args 0]
    	set key "[lrange $args 1 end]"
    	#set line "Key for $ch set to *censored*"
    	set line "Key for $ch set to $key"
    	if {![info exists blowkey([string tolower $nick])]} {return}
    	set tmp [encrypt $blowkey([string tolower $nick]) $line]
    	set blowkey($ch) "$key"
    	save_keys $ch $key
    	puthelp "PRIVMSG $nick :$line"
}

bind nick * * nick_change

proc nick_change {nick uhost hand dest what} {
        global blowkey
        set nick [string tolower $nick]
        set what [string tolower $what]
	if {[info exists blowkey($nick)]} {
		set ::blowkey($what) $blowkey($nick)
	}
}

proc save_keys {ch key} {
	global blowkey
	set fs [open $ch.key w+]
	puts $fs "$key"
	close $fs
	catch { exec chmod 600 $ch.key }
}

proc read_keys { ch } {
    	global blowkey
    	if {[file exists $ch.key]} {
		set fs [open $ch.key r]
		while {![eof $fs]} {
    			gets $fs line
    			if {$line == ""} {
    				close $fs
    				return
    			}
    			set blowkey($ch) "$line"
    		}
    		close $fs
    	}
}

proc check_ch {nick uhost hand chan} {
    	global botnick
    	if {[isbotnick $nick]} {
        	read_keys $chan
    	}
}

bind pub - +OK encryptedincominghandler
bind msg - +OK encryptedmsgincominghandler
bind pub - mcps encryptedincominghandler
bind msg - mcps encryptedmsgincominghandler
bind msg - !bckeydel bckeydel
bind msg n|m !chkey ch_blowkey
bind notc - "DH1080_INIT *" keyexinit
bind notc - "DH1080_FINISH *" keyexfinish
bind join - * check_ch
set my_name [info script]
set my_dir [file dirname $my_name]
catch { exec chmod 600 [pwd]/$my_name }

putlog "$my_name loaded"
